using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using System.Collections;
using System.Threading;
using System.Text.RegularExpressions;

//Version 5.0
namespace AlertApp
{
    public partial class AlertSettings : Form
    {
        API.CustomerApi api = new API.CustomerApi();
        string key = ConfigurationManager.AppSettings.Get("key");
        string Bandwidth;
        string DiskQuota;
        string Domain;
        string DatabaseName;
        string DatabaseUsage;
        string DatabaseType;

        static int SettingsEnableFlag = 0;
        string setDiskBWFlag;
        string setEmailFlag;
        string setDatabaseFlag;
        static int alertcount = 0;
        ArrayList DiskBWAlertList = new ArrayList();
        ArrayList EmailAlertList = new ArrayList();
        ArrayList DatabaseAlertList = new ArrayList();
        ArrayList NewsAlertList = new ArrayList();
        ArrayList DatabaseList = new ArrayList();




        private class MyObject
        {
            public string Name;
            public string Value;

            public MyObject(string name, string value)
            {
                Name = name;
                Value = value;
            }

            public override string ToString()
            {
                return Name;
            }
        }


        public AlertSettings()
        {
            InitializeComponent();

        }

        //Initializes all the Stored Settings from app.config
        private void Settings_Load(object sender, EventArgs e)
        {

            cmbDatabaseType.Items.Add(new MyObject("MSSQL2005", "1"));
            cmbDatabaseType.Items.Add(new MyObject("MSSQL2000", "2"));
            cmbDatabaseType.Items.Add(new MyObject("MYSQL", "3"));

            //Set EmailUsage and DatabaseUsage Slider Max and Min

            tbarEmailUsage.Maximum = 100;
            tbarEmailUsage.Minimum = 0;
            tbarDatabase.Maximum = 100;
            tbarDatabase.Minimum = 0;

            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);

            for (int k = 0; k <= config.AppSettings.Settings.Count - 1; k++)
            {
                if (ConfigurationManager.AppSettings.GetKey(k).Length > 12)
                {
                    if (ConfigurationManager.AppSettings.GetKey(k).Substring(0, 8).ToString() == "Database")
                    {
                        string key = ConfigurationManager.AppSettings.GetKey(k).ToString();
                        DatabaseList.Add(key.Substring(8));
                        lstDatabase.Items.Add(new MyObject(key.Substring(8), ConfigurationManager.AppSettings[key]));
                    }
                }
            }

            if (ConfigurationManager.AppSettings["key"] != null)
            {
                txtKey.Text = key;

            }


            if (ConfigurationManager.AppSettings["Domain"] != null)
            {
                txtDomain.Text = ConfigurationManager.AppSettings["Domain"];

            }




            if (ConfigurationManager.AppSettings["Status"] == "ON")
            {

                btnAlertMode.Text = "OFF";
                lblStatusInfo.Text = "Alert Turned On";
                NICON.Text = "DiscountASP.NET Alert-Enabled";
                SettingsEnableFlag = 1;

            }
            else
            {
                NICON.Text = "DiscountASP.NET Alert-Disabled";
            }

            //Check whether DiskBW  Alert is Disabled or Enabled
            if (ConfigurationManager.AppSettings["StatusDiskBW"] == "Enabled")
            {

                btnDisableDiskBW.Text = "Disable";
                pnlDiskBW.Enabled = true;

            }
            else
            {

                btnDisableDiskBW.Text = "Enable";
                pnlDiskBW.Enabled = false;
            }

            if (ConfigurationManager.AppSettings["StatusNews"] == "Enabled")
            {
                CheckNews_Tick_Caller(sender, e);
                btnDisableNews.Text = "Disable";
                pnlNews.Enabled = true;


            }
            else
            {

                btnDisableNews.Text = "Enable";
                pnlNews.Enabled = false;
            }



            //Prefill Bandwidth Setting
            if (ConfigurationManager.AppSettings["Bandwidth"] != null)
            {
                txtBandwidth.Text = ConfigurationManager.AppSettings["Bandwidth"];

            }
            //Prefill DiskQuota Setting
            if (ConfigurationManager.AppSettings["DiskQuota"] != null)
            {
                txtDiskUsage.Text = ConfigurationManager.AppSettings["DiskQuota"];

            }
            //Check whether Email Alert is Disabled or Enabled
            if (ConfigurationManager.AppSettings["StatusEmail"] == "Enabled")
            {

                btnDisableEmail.Text = "Disable";
                pnlEmail.Enabled = true;
            }
            else
            {

                btnDisableEmail.Text = "Enable";
                pnlEmail.Enabled = false;
            }
            //Prefill Email Usage Threshold
            if (ConfigurationManager.AppSettings["PopEmailUsage"] != null)
            {
             
                tbarEmailUsage.Value = Convert.ToInt32(ConfigurationManager.AppSettings["PopEmailUsage"]);
                lbltbarvalue.Text = tbarEmailUsage.Value.ToString();

            }

            //Prefill Total Email Usage Threshold
            if (ConfigurationManager.AppSettings["PopTotalUsage"] != null)
            {
                txtEmailTotalUsage.Text = ConfigurationManager.AppSettings["PopTotalUsage"];
            }

            //Check whether Database Alert is Disabled or Enabled
            if (ConfigurationManager.AppSettings["StatusDatabase"] == "Enabled")
            {
                btnDisableDatabase.Text = "Disable";
                grpDatabase.Enabled = true;

            }
            else
            {
                btnDisableDatabase.Text = "Enable";
                grpDatabase.Enabled = false;

            }

        }


        //Exit Option on Notifier
        private void Exit(object sender, CancelEventArgs e)
        {
            NICON.Visible = true;
            this.ShowInTaskbar = false;
            this.WindowState = FormWindowState.Normal;
        }

        //Called by CheckDiskBW_Tick_Caller to check Disk and Bandwidth Usage
        private void CheckDiskBW_Tick()
        {
            string val;
            int bwflag = 0;
            int dqflag = 0;
            int bwcheckflag = 0;
            string month = DateTime.Now.Month.ToString();
            string year = DateTime.Now.Year.ToString();
            DateTime startdate = Convert.ToDateTime(month + "/" + "01/" + year);
            DateTime enddate = DateTime.Now.Date;
        

            try
            {
                //Check whether key is valid and Alert is ON
                if (SettingsEnableFlag != 0 && api.VerifyKey(key))
                {

                    Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
                    for (int k = 0; k <= config.AppSettings.Settings.Count - 1; k++)
                    {
                        if (ConfigurationManager.AppSettings.GetKey(k).ToString() == "Bandwidth")
                        {
                            bwflag = 1;
                            Bandwidth = ConfigurationManager.AppSettings["Bandwidth"];

                        }
                        if (ConfigurationManager.AppSettings.GetKey(k).ToString() == "DiskQuota")
                        {
                            dqflag = 1;
                            DiskQuota = ConfigurationManager.AppSettings["DiskQuota"];

                        }
                    }

                    setDiskBWFlag = ConfigurationManager.AppSettings["StatusDiskBW"];
                    DiskBWAlertList.Clear();

                    //Check BW on if Set or If BandWidth Setting Exists
                    if (setDiskBWFlag == "Enabled" && bwflag == 1)
                    {
                        
                      
                        DataSet BandwidthUsage = api.BandwidthGetUsage(key, startdate, enddate);
                        txtActivities.Text += "Checking Bandwidth..."+  "\r\n" ;
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();
                        foreach (DataRow dr in BandwidthUsage.Tables[0].Rows)
                        {
                            val = dr["Quantity"].ToString();
                            if (val != "")
                            {
                                if (Convert.ToDouble(val) >= Convert.ToDouble(Bandwidth) * 1000)
                                {
                                    bwcheckflag = 1;

                                }
                            }

                        }
                        if (bwcheckflag == 1)
                        {
                            DiskBWAlertList.Add("Bandwidth Exceeded " + Bandwidth + " GB");
                        }
                        System.Threading.Thread.Sleep(3000);
                        txtActivities.Text += "Bandwidth Check Completed  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();
                    }

                    if (setDiskBWFlag == "Enabled" && dqflag == 1)
                    {
                        txtActivities.Text += "Checking DisQuota..." + "\r\n";
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();
                        int DiskUsage = api.DiskQuotaGetUsageTotal(key);
                        if (Convert.ToDouble(DiskUsage) >= Convert.ToDouble(DiskQuota))
                        {
                            DiskBWAlertList.Add("DiskQuota Exceeded " + DiskQuota + " MB");

                        }
                        System.Threading.Thread.Sleep(3000);
                        txtActivities.Text += "DiskQuota Check Completed  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                        txtActivities.SelectionStart = txtActivities.Lines.Length;
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();
                    }


                    if (DiskBWAlertList.Count > 1)
                    {
                        String CombinedDiskBWAlert = "";
                        CombinedDiskBWAlert = DiskBWAlertList[0].ToString() + " and " + DiskBWAlertList[1].ToString();

                        NICON.BalloonTipTitle = "DISCOUNTASP.NET ALERT";
                        NICON.BalloonTipText = CombinedDiskBWAlert + "\n" + "Click here for more Details.";

                        NICON.BalloonTipClicked += delegate(object obj, EventArgs args)
                    {
                        System.Diagnostics.Process.Start("IExplore.exe", "https://my.discountasp.net/usage-summary.aspx");


                    };
                        NICON.ShowBalloonTip(5000);

                        lblDiskBWAlert.Visible = true;
                        if (alertcount < 10)
                        {
                            lblDiskBWAlert.Text += "Alert Msg: " + DiskBWAlertList[0].ToString() + "    Time : " + DateTime.Now + "\n";
                            alertcount++;
                            lblDiskBWAlert.Text += "Alert Msg: " + DiskBWAlertList[1].ToString() + "    Time : " + DateTime.Now + "\n";
                            alertcount++;


                        }
                        else
                        {
                            lblDiskBWAlert.Text = "";
                            alertcount = 0;
                            lblDiskBWAlert.Text += "Alert Msg: " + DiskBWAlertList[0].ToString() + "    Time : " + DateTime.Now + "\n";
                            alertcount++;
                            lblDiskBWAlert.Text += "Alert Msg: " + DiskBWAlertList[1].ToString() + "    Time : " + DateTime.Now + "\n";
                            alertcount++;

                        }
                    }
                    else if (DiskBWAlertList.Count == 1)
                    {
                        NICON.BalloonTipTitle = "DISCOUNTASP.NET ALERT";
                        NICON.BalloonTipText = DiskBWAlertList[0].ToString() + "\n" + "Click here for more Details";
                        NICON.ShowBalloonTip(5000);
                        NICON.BalloonTipClicked += delegate(object obj, EventArgs args)
              {
                  System.Diagnostics.Process.Start("IExplore.exe", "https://my.discountasp.net/usage-summary.aspx");


              };
                        lblDiskBWAlert.Visible = true;
                        if (alertcount < 10)
                        {
                            lblDiskBWAlert.Text += "Alert Msg: " + DiskBWAlertList[0].ToString() + "    Time : " + DateTime.Now;
                            lblDiskBWAlert.Text += "\n";
                            alertcount++;
                        }
                        else
                        {
                            lblDiskBWAlert.Text = "";
                            alertcount = 0;
                            lblDiskBWAlert.Text += "Alert Msg: " + DiskBWAlertList[0].ToString() + "    Time : " + DateTime.Now + "\n";
                            alertcount++;
                        }

                    }
                    DiskBWAlertList.Clear();
                   

                }


            }
            catch (Exception ex)
            {
                AccountTab.SelectedIndex = 0;

                if (this.Visible == false)
                {
                    NICON.BalloonTipTitle = "DISCOUNTASP.NET ALERT";
                    NICON.BalloonTipTitle = "ERROR";
                    NICON.BalloonTipText = "Service Temporarily Unavailable";
                    NICON.ShowBalloonTip(5000);
                }
                else
                {
                    MessageBox.Show("Error" + ex.Message.ToString());
                    txtActivities.Text += "Database/Bandwidth cannot be checked at the moment...  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                    txtActivities.Select(txtActivities.Text.Length, 0);
                    txtActivities.ScrollToCaret();
                }

            }

        }


        //Sets Alert Mode to ON/OFF
        private void btnAlertMode_Click(object sender, EventArgs e)
        {
             
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            if (btnAlertMode.Text == "ON")
            {
                SettingsEnableFlag = 1;
                lblStatusInfo.Text = "Alert Enabled";
                btnAlertMode.Text = "OFF";
                NICON.Text = "DiscountASP.NET Alert-Enabled";
                if (txtDomain.Text != "")
                {

                    if (ConfigurationManager.AppSettings["key"] != null)
                    {
                        config.AppSettings.Settings.Remove("key");
                    }
                    config.AppSettings.Settings.Add("key", txtKey.Text.ToString());
                    if (ConfigurationManager.AppSettings["Domain"] != null)
                    {
                        config.AppSettings.Settings.Remove("Domain");
                    }
                    config.AppSettings.Settings.Add("Domain", txtDomain.Text.ToString());

                    if (ConfigurationManager.AppSettings["Status"] != null)
                    {
                        config.AppSettings.Settings.Remove("Status");
                    }
                    config.AppSettings.Settings.Add("Status", "ON");


                }
                else
                {
                    lblStatusInfo.Text = "Domain Name cannot be Empty";
                }



            }
            else
            {
                SettingsEnableFlag = 0;
                btnAlertMode.Text = "ON";
                NICON.Text = "DiscountASP.NET Alert-Disabled";
                if (ConfigurationManager.AppSettings["Status"] != "")
                {
                    config.AppSettings.Settings.Remove("Status");
                }
                lblStatusInfo.Text = "Alert Disabled";
            }
            config.Save(ConfigurationSaveMode.Modified);
            ConfigurationManager.RefreshSection("appSettings");

        }
        //Validates Key at an Interval
        private void ValidateKey_Tick(object sender, EventArgs e)
        {
            if (SettingsEnableFlag != 0)
            {
                try
                {
                    Boolean ValidKey = api.VerifyKey(key);
                }
                catch
                {
                    if (key == "")
                    {
                        lblStatusInfo.Text = "Key Required-Please Enter a Valid Key";

                    }
                    else
                    {
                        lblStatusInfo.Text = "Invalid Key-Please Enter a Valid Key";
                    }
                    SettingsEnableFlag = 0;

                }
            }
        }

        //Minimizes Settings
        protected override void OnResize(EventArgs e)
        {
            if (this.WindowState == FormWindowState.Minimized)
                this.Hide();
            base.OnResize(e);
        }


        //Check whether value is Numeric
        private bool IsNumeric(object ValueToCheck)
        {
            double Dummy = new double();
            string InputValue = Convert.ToString(ValueToCheck);

            bool Numeric = double.TryParse(InputValue, System.Globalization.NumberStyles.Any, null, out Dummy);

            return Numeric;
        }

        //Saves Bandwidth Settings
        private void btnSetBandwidthDisk_Click(object sender, EventArgs e)
        {
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            key = ConfigurationManager.AppSettings.Get("key");

            if (txtBandwidth.Text != "")
            {

                if (!IsNumeric(txtBandwidth.Text))
                {
                    lblDiskBWValidate.Text = "DiskQuota/Bandwidth should be Numeric";

                }
                else
                {
                    if (ConfigurationManager.AppSettings["Bandwidth"] != null)
                    {
                        config.AppSettings.Settings.Remove("Bandwidth");
                    }
                    config.AppSettings.Settings.Add("Bandwidth", txtBandwidth.Text.ToString());


                }
            }

            else
            {
                if (ConfigurationManager.AppSettings["Bandwidth"] != null)
                {
                    config.AppSettings.Settings.Remove("Bandwidth");
                }

            }

            if (txtDiskUsage.Text != "")
            {

                if (!IsNumeric(txtDiskUsage.Text))
                {
                    lblDiskBWValidate.Text = "DiskQuota/Bandwidth should be Numeric";

                }
                else
                {
                    if (ConfigurationManager.AppSettings["DiskQuota"] != null)
                    {
                        config.AppSettings.Settings.Remove("DiskQuota");
                    }
                    config.AppSettings.Settings.Add("DiskQuota", txtDiskUsage.Text.ToString());


                }
            }

            else
            {
                if (ConfigurationManager.AppSettings["DiskQuota"] != null)
                {
                    config.AppSettings.Settings.Remove("DiskQuota");
                }

            }
            if (IsNumeric(txtDiskUsage.Text) && IsNumeric(txtBandwidth.Text))
            {
                lblDiskBWValidate.Text = "";
            }

            config.Save(ConfigurationSaveMode.Modified);
            ConfigurationManager.RefreshSection("appSettings");
            CheckDiskBW_Tick_Caller(sender, e);




        }

        private void exitToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void ICON_CLICK_MAXIMIZE(object sender, MouseEventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
        }

        //Saves Email Settings
        private void btnSetEmail_Click(object sender, EventArgs e)
        {
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            key = ConfigurationManager.AppSettings.Get("key");

            if (tbarEmailUsage.Value.ToString() != "")
            {
                if (ConfigurationManager.AppSettings["PopEmailUsage"] != "")
                {
                    config.AppSettings.Settings.Remove("PopEmailUsage");
                }

                config.AppSettings.Settings.Add("PopEmailUsage", tbarEmailUsage.Value.ToString());


            }




            if (txtEmailTotalUsage.Text != "")
            {

                if (!IsNumeric(txtEmailTotalUsage.Text))
                {
                    lblError.Text = "Total Email Usage should be Numeric";

                }
                else
                {
                    if (ConfigurationManager.AppSettings["PopTotalUsage"] != null)
                    {
                        config.AppSettings.Settings.Remove("PopTotalUsage");
                    }
                    config.AppSettings.Settings.Add("PopTotalUsage", txtEmailTotalUsage.Text.ToString());
                    lblError.Text = "";


                }
            }

            else
            {
                if (ConfigurationManager.AppSettings["PopTotalUsage"] != "")
                {
                    config.AppSettings.Settings.Remove("PopTotalUsage");
                }

            }



            config.Save(ConfigurationSaveMode.Modified);
            ConfigurationManager.RefreshSection("appSettings");
            CheckEmail_Tick_Caller(sender, e);





        }


        // //Check Email Thread

        private void CheckEmail_Tick_Caller(object sender, EventArgs e)
        {
            System.Threading.ThreadStart thr_start_func2 = new System.Threading.ThreadStart(CheckEmail_Tick);
            System.Threading.Thread CheckEmailThread = new System.Threading.Thread(thr_start_func2);
            CheckEmailThread.Start();
            CheckForIllegalCrossThreadCalls = false;

        }

        //Check Disk and Bandwidth Thread
        private void CheckDiskBW_Tick_Caller(object sender, EventArgs e)
        {

            System.Threading.ThreadStart thr_start_func2 = new System.Threading.ThreadStart(CheckDiskBW_Tick);
            System.Threading.Thread CheckDiskBWThread = new System.Threading.Thread(thr_start_func2);
            CheckForIllegalCrossThreadCalls = false;
            CheckDiskBWThread.Start();


        }
        //Check Database Thread

        private void CheckDataBase_Tick_Caller(object sender, EventArgs e)
        {
            System.Threading.ThreadStart thr_start_func2 = new System.Threading.ThreadStart(CheckDataBase_Tick);
            System.Threading.Thread CheckDatabaseThread = new System.Threading.Thread(thr_start_func2);
            CheckForIllegalCrossThreadCalls = false;
            CheckDatabaseThread.Start();


        }




        //Called by CheckEmail_Tick_Caller to check Email Usage and also gets List of Emails that exceeds the set threshold
        private void CheckEmail_Tick()
        {
            try
            {

                int count = 0;
                string PopEmailUsage;
                string PopTotalUsage;
                ArrayList lstPopEmails = new ArrayList();
                lstAlertpop.Items.Clear();


                //Check whether key is valid and Alert is ON
                if (SettingsEnableFlag != 0 && api.VerifyKey(key))
                {

                    Domain = ConfigurationManager.AppSettings["Domain"];
                    PopEmailUsage = ConfigurationManager.AppSettings["PopEmailUsage"];
                    PopTotalUsage = ConfigurationManager.AppSettings["PopTotalUsage"];
                    setEmailFlag = ConfigurationManager.AppSettings["StatusEmail"];


                    if (setEmailFlag == "Enabled" && PopEmailUsage != null)
                    {

                        API.EmailAccountPop[] emailaccounts = api.EmailGetAllPop(key, Domain);
                        txtActivities.Text += "Checking Individual Email Thresholds..."+ "\r\n" ;
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();

                        for (int k = 0; k <= emailaccounts.Length - 1; k++)
                        {
                            decimal emailusage;


                            emailusage = api.EmailGetUsage(key, Domain, emailaccounts[k].UserName.ToString());

        
                            if (((emailusage/1000) / Convert.ToDecimal(emailaccounts[k].quota.ToString()) * 100) >= Convert.ToDecimal(PopEmailUsage))
                            {
                                
                                lstPopEmails.Add(emailaccounts[k].UserName.ToString());
                                count++;

                            }

                   
                        }
                        System.Threading.Thread.Sleep(3000);
                        if (count > 0)
                        {
                            EmailAlertList.Add(count.ToString() + " Emails Exceeded " + PopEmailUsage + " % of Usage");
                        }


                    // Generates List Of Usernames that exceeded Threshold
                    if (lstPopEmails.Count > 0)
                    {
                        lblError.Visible = true;
                        txtActivities.Text += "Loading Email List..." + "\r\n";
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();

                        System.Threading.Thread.Sleep(3000);
                        if (PopTotalUsage == null)
                        {
                            txtActivities.Text += "Email Check Completed  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                            txtActivities.Select(txtActivities.Text.Length, 0);
                            txtActivities.ScrollToCaret();
                        }
                        lblError.Text = "";

                        lblEmailAlerts.Visible = true;
                        lstAlertpop.Visible = true;

                        for (int j = 0; j <= lstPopEmails.Count - 1; j++)
                        {
                            lstAlertpop.Items.Add(lstPopEmails[j].ToString());
                        }

                    }
                    else
                    {
                        txtActivities.Text += "Email Check Completed  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                    }
                }




                    if (setEmailFlag == "Enabled" && PopTotalUsage != null)
                    {
                        txtActivities.Text += "Checking Total Email Threshold..." +  "\r\n" ;
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();
                        decimal emailtotalusage = api.EmailGetUsageTotal(key, Domain);
                        if ((emailtotalusage/1000) >= Convert.ToDecimal(PopTotalUsage))
                        {
                            EmailAlertList.Add("Total Email Quota Exceeded " + PopTotalUsage + "MB");


                        }
                        System.Threading.Thread.Sleep(3000);
                        txtActivities.Text += "Email Check Completed  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();
                       
                        
                    }

                    if (EmailAlertList.Count > 1)
                    {
                        String CombinedEmailAlert = "";
                        CombinedEmailAlert = EmailAlertList[0].ToString() + " and " + EmailAlertList[1].ToString() + "\n" + "Click Here for more Details.";
                        NICON.BalloonTipTitle = "DISCOUNTASP.NET ALERT";
                        NICON.BalloonTipText = CombinedEmailAlert;
                        NICON.ShowBalloonTip(5000);
                        NICON.BalloonTipClicked += delegate(object obj, EventArgs args)
                        {
                            Show();
                            WindowState = FormWindowState.Normal;
                            this.AccountTab.SelectTab("tbAlertSettings");
                            this.tabAlerts.SelectTab("tabEmail");

                        };


                        if (alertcount < 9)
                        {
                            lblDiskBWAlert.Text += "Alert Msg: " + EmailAlertList[0].ToString() + " Time : " + DateTime.Now;
                            alertcount++;
                            lblDiskBWAlert.Text += "\n";
                            lblDiskBWAlert.Text += "Alert Msg: " + EmailAlertList[1].ToString() + " Time : " + DateTime.Now;
                            alertcount++;
                            lblDiskBWAlert.Text += "\n";

                        }
                        else
                        {
                            lblDiskBWAlert.Text = "";
                            alertcount = 0;
                            lblDiskBWAlert.Text += "Alert Msg: " + EmailAlertList[0].ToString() + " Time : " + DateTime.Now;
                            alertcount++;
                            lblDiskBWAlert.Text += "\n";
                            lblDiskBWAlert.Text += "Alert Msg: " + EmailAlertList[1].ToString() + " Time : " + DateTime.Now;
                            alertcount++;
                            lblDiskBWAlert.Text += "\n";

                        }



                    }
                    else if (EmailAlertList.Count == 1)
                    {
                        if (alertcount < 9)
                        {
                            lblDiskBWAlert.Text += "Alert Msg: " + EmailAlertList[0].ToString() + " Time : " + DateTime.Now;
                            alertcount++;
                            lblDiskBWAlert.Text += "\n";

                        }
                        else
                        {
                            lblDiskBWAlert.Text = "";
                            alertcount = 0;
                            lblDiskBWAlert.Text += "Alert Msg: " + EmailAlertList[0].ToString() + " Time : " + DateTime.Now;
                            alertcount++;
                            lblDiskBWAlert.Text += "\n";

                        }

                        NICON.BalloonTipTitle = "DISCOUNTASP.NET ALERT";
                        NICON.BalloonTipText = EmailAlertList[0].ToString() + "\n" + "Click Here for more Details."; ;
                        NICON.ShowBalloonTip(5000);
                        NICON.BalloonTipClicked += delegate(object obj, EventArgs args)
                    {
                        Show();
                        WindowState = FormWindowState.Normal;
                        this.AccountTab.SelectTab("tbAlertSettings");
                        this.tabAlerts.SelectTab("tabEmail");

                    };


                    }
                    EmailAlertList.Clear();

                }

            }
            catch (Exception ex)
            {

                if (this.Visible == false)
                {
                    NICON.BalloonTipTitle = "ERROR";
                    NICON.BalloonTipText = "Service Temporarily Unavailable";
                    NICON.ShowBalloonTip(5000);
                }
                else
                {
                    MessageBox.Show("Error " + ex.Message.ToString());
                    txtActivities.Text += "Emails cannot be checked at the moment...  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                    txtActivities.Select(txtActivities.Text.Length, 0);
                    txtActivities.ScrollToCaret();
                }
            }
        }




        //Disables DISK and Bandwidth check by changing  StatuDiskBW in the app.exe.config
        private void btnDisableDiskBW_Click(object sender, EventArgs e)
        {
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            key = ConfigurationManager.AppSettings.Get("key");
            if (btnDisableDiskBW.Text == "Disable")
            {


                btnDisableDiskBW.Text = "Enable";
                pnlDiskBW.Enabled = false;
                if (ConfigurationManager.AppSettings["StatusDiskBW"] != "")
                {
                    config.AppSettings.Settings.Remove("StatusDiskBW");
                    config.AppSettings.Settings.Add("StatusDiskBW", "Disabled");
                }
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");

            }
            else
            {


                btnDisableDiskBW.Text = "Disable";
                if (ConfigurationManager.AppSettings["Bandwidth"] != "")
                {
                    config.AppSettings.Settings.Remove("StatusDiskBW");
                    config.AppSettings.Settings.Add("StatusDiskBW", "Enabled");
                }
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");
                CheckDiskBW_Tick_Caller(sender, e);
                pnlDiskBW.Enabled = true;


            }


        }
        //Disables Email Usage check by changing  StatusEmail in the app.exe.config
        private void btnDisableEmail_Click(object sender, EventArgs e)
        {
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            key = ConfigurationManager.AppSettings.Get("key");
            if (btnDisableEmail.Text == "Disable")
            {


                btnDisableEmail.Text = "Enable";
                pnlEmail.Enabled = false;
                if (ConfigurationManager.AppSettings["StatusEmail"] != "")
                {
                    config.AppSettings.Settings.Remove("StatusEmail");
                    config.AppSettings.Settings.Add("StatusEmail", "Disabled");
                }
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");
            }
            else
            {

                btnDisableEmail.Text = "Disable";
                if (ConfigurationManager.AppSettings["StatusEmail"] != "")
                {
                    config.AppSettings.Settings.Remove("StatusEmail");
                    config.AppSettings.Settings.Add("StatusEmail", "Enabled");
                }
                pnlEmail.Enabled = true;
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");
                CheckEmail_Tick_Caller(sender, e);
            }



        }
        //Adds Database to the List of Databases to check
        private void btnDBAdd_Click(object sender, EventArgs e)
        {
            int Flag = 0;
            MyObject o = (MyObject)cmbDatabaseType.SelectedItem;

            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            key = ConfigurationManager.AppSettings.Get("key");
            // if (txtDatabase.Text != "" && txtDatabaseUsage.Text != "" && o.Name.ToString()!="")
            if (txtDatabase.Text != "" && tbarDatabase.Value.ToString() != "" && o.Name.ToString() != "")
            {
                for (int h = 0; h <= lstDatabase.Items.Count - 1; h++)
                {
                    if (lstDatabase.Items[h].ToString() == txtDatabase.Text)
                    {
                        lblDBErrors.Visible = true;
                        lblDBError.Visible = true;
                        lblDBError.Text = "Database  " + txtDatabase.Text + " already Exists ";
                        Flag = 1;
                    }
                }


                if (Flag != 1)
                {
                    //lstDatabase.Items.Add(new MyObject(txtDatabase.Text, o.Value + "," + txtDatabaseUsage.Text));
                    lstDatabase.Items.Add(new MyObject(txtDatabase.Text, o.Value + "," + tbarDatabase.Value.ToString()));
                    config.AppSettings.Settings.Add("Database" + txtDatabase.Text, o.Value.ToString());
                    //  config.AppSettings.Settings.Add("Database" + txtDatabase.Text, txtDatabaseUsage.Text);
                    config.AppSettings.Settings.Add("Database" + txtDatabase.Text, tbarDatabase.Value.ToString());

                }

            }
            else
            {
                lblDBErrors.Visible = true;
                lblDBError.Visible = true;
                lblDBError.Text = "DatabaseName/Database Usage/Database Type cannot be Empty";

            }

            config.Save(ConfigurationSaveMode.Modified);
            ConfigurationManager.RefreshSection("appSettings");
            CheckDataBase_Tick_Caller(sender, e);

        }


        //Called by CheckDataBase_Tick_Caller to check for Database Usage
        private void CheckDataBase_Tick()
        {
            try
            {
                setDatabaseFlag = ConfigurationManager.AppSettings["StatusDatabase"];
                if (SettingsEnableFlag != 0 && api.VerifyKey(key))
                {
                    if (lstDatabase.Items.Count > 0 && setDatabaseFlag == "Enabled")
                    {
                        txtActivities.Text += "Checking Database Usage..."+ "\r\n" ;
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();
                        for (int t = 0; t <= lstDatabase.Items.Count - 1; t++)
                        {
                           

                            DatabaseName = ((MyObject)lstDatabase.Items[t]).Name.ToString();
                            DatabaseUsage = ((MyObject)lstDatabase.Items[t]).Value.ToString().Substring(2);
                            DatabaseType = ((MyObject)lstDatabase.Items[t]).Value.ToString().Substring(0, 1);

                            if (DatabaseType == "1")
                            {
                                API.DbUsageResult MSSQL2k5DBResult = api.Sql2005GetUsage(key, DatabaseName);
                               
                                if (Convert.ToDouble((MSSQL2k5DBResult.Usage) * 100) / MSSQL2k5DBResult.Quota >= Convert.ToDouble(DatabaseUsage))
                                {
                                    DatabaseAlertList.Add("Total MSSQL2K5 Quota Exceeded " + DatabaseUsage + "% for " + DatabaseName);
                                    if (alertcount < 9)
                                    {
                                        lblDiskBWAlert.Text += "Alert Msg: " + DatabaseName + " Quota Exceeded " + DatabaseUsage + "%" + "    Time : " + DateTime.Now;
                                        lblDiskBWAlert.Text += "\n";
                                        alertcount++;
                                    }
                                    else
                                    {
                                        lblDiskBWAlert.Text = "";
                                        alertcount = 0;
                                        lblDiskBWAlert.Text += "Alert Msg: " + DatabaseName + " Quota Exceeded " + DatabaseUsage + "%" + "    Time : " + DateTime.Now + "\n";
                                        alertcount++;

                                    }


                                }

                            }

                            else if (DatabaseType == "2")
                            {


                                API.DbUsageResult MSSQL2kDBResult = api.Sql2000GetUsage(key, DatabaseName);
                              
                                if (Convert.ToDouble((MSSQL2kDBResult.Usage) * 100) / MSSQL2kDBResult.Quota >= Convert.ToDouble(DatabaseUsage))
                                {
                                    DatabaseAlertList.Add("Total MSSQL2K Quota Exceeded " + DatabaseUsage + "% for " + DatabaseName);
                                    if (alertcount < 9)
                                    {
                                        lblDiskBWAlert.Text += "Alert Msg: " + DatabaseName + " Quota Exceeded " + DatabaseUsage + "%" + "    Time : " + DateTime.Now;
                                        lblDiskBWAlert.Text += "\n";
                                        alertcount++;
                                    }
                                    else
                                    {
                                        lblDiskBWAlert.Text = "";
                                        alertcount = 0;
                                        lblDiskBWAlert.Text += "Alert Msg: " + DatabaseName + " Quota Exceeded " + DatabaseUsage + "%" + "    Time : " + DateTime.Now + "\n";
                                        alertcount++;
                                    }

                                }

                            }

                            else if (DatabaseType == "3")
                            {

                                API.DbUsageResult MYSQLDBResult = api.MySqlGetUsage(key, DatabaseName);
                              
                                if (Convert.ToDouble((MYSQLDBResult.Usage) * 100) / MYSQLDBResult.Quota >= Convert.ToDouble(DatabaseUsage))
                                {
                                    DatabaseAlertList.Add("Total MSSQL2K Quota Exceeded " + DatabaseUsage + "% for" + DatabaseName);
                                    if (alertcount < 9)
                                    {
                                        lblDiskBWAlert.Text += "Alert Msg: " + DatabaseName + " Quota Exceeded " + DatabaseUsage + "%" + "    Time : " + DateTime.Now;
                                        lblDiskBWAlert.Text += "\n";
                                        alertcount++;
                                    }
                                    else
                                    {
                                        lblDiskBWAlert.Text = "";
                                        alertcount = 0;
                                        lblDiskBWAlert.Text += "Alert Msg: " + DatabaseName + " Quota Exceeded " + DatabaseUsage + "%" + "    Time : " + DateTime.Now + "\n";
                                        alertcount++;
                                    }

                                }

                            }
                            if (lstDatabase.Items.Count > 1)
                            {
                                System.Threading.Thread.Sleep(120000);
                            }



                        }
                        System.Threading.Thread.Sleep(3000);
                        txtActivities.Text += "Database Check Completed  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();
                      
                       
                        String CombinedDatabaseAlert = "";

                        for (int p = 0; p <= DatabaseAlertList.Count - 1; p++)
                        {
                            if (DatabaseAlertList.Count > 0)
                            {

                                CombinedDatabaseAlert += DatabaseAlertList[p].ToString();
                                if (p == DatabaseAlertList.Count - 1)
                                {
                                    CombinedDatabaseAlert += " .";
                                }
                                else
                                {
                                    CombinedDatabaseAlert += " and ";
                                }

                            }

                        }
                        //Notify Balloon Alert 
                        if (CombinedDatabaseAlert != "")
                        {
                            NICON.BalloonTipText = CombinedDatabaseAlert + "\n" + "Click Here";
                            NICON.BalloonTipTitle = "DISCOUNTASP.NET ALERT";
                            NICON.BalloonTipClicked += delegate(object obj, EventArgs args)
                           {
                               System.Diagnostics.Process.Start("IExplore.exe", "https://my.discountasp.net/addons/");

                           };

                            NICON.ShowBalloonTip(5000);


                        }
                        DatabaseAlertList.Clear();
                    }

                }
            }
            catch (Exception ex)
            {
                AccountTab.SelectedIndex = 0;

                if (this.Visible == false)
                {

                    NICON.BalloonTipTitle = "ERROR";
                    NICON.BalloonTipText = "Service Temporarily Unavailable";
                    NICON.ShowBalloonTip(5000);
                }
                else
                {
                    MessageBox.Show("Error " + ex.Message.ToString());
                    txtActivities.Text += "Database cannot be checked at the moment...  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                    txtActivities.Select(txtActivities.Text.Length, 0);
                    txtActivities.ScrollToCaret();
                }

            }

        }


        //Deletes Database from the List of Databases to be checked
        private void btnDatabaseDelete_Click(object sender, EventArgs e)
        {
            MyObject o = (MyObject)lstDatabase.SelectedItem;
            if (lstDatabase.SelectedIndex > -1)
            {
                lstDatabase.Items.RemoveAt(lstDatabase.SelectedIndex);
                Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
                config.AppSettings.Settings.Remove("Database" + o.Name.ToString());
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");
            }
            else
            {
                lblDBErrors.Visible = true;
                lblDBError.Visible = true;
                lblDBError.Text = "Please Select a Database to Remove";
            }


        }

        //Disables Database check by changing the settings in app.exe.config
        private void btnDisableDatabase_Click(object sender, EventArgs e)
        {
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            key = ConfigurationManager.AppSettings.Get("key");
            if (btnDisableDatabase.Text == "Disable")
            {
                btnDisableDatabase.Text = "Enable";
                grpDatabase.Enabled = false;
                if (ConfigurationManager.AppSettings["StatusDatabase"] != "")
                {
                    config.AppSettings.Settings.Remove("StatusDatabase");
                    config.AppSettings.Settings.Add("StatusDatabase", "Disabled");

                }
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");

            }
            else
            {

                btnDisableDatabase.Text = "Disable";
                grpDatabase.Enabled = true;
                if (ConfigurationManager.AppSettings["StatusDatabase"] != "")
                {
                    config.AppSettings.Settings.Remove("StatusDatabase");
                    config.AppSettings.Settings.Add("StatusDatabase", "Enabled");
                }
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");
                CheckDataBase_Tick_Caller(sender, e);


            }



        }

        private void EmailManagerLink(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("IExplore.exe", "https://my.discountasp.net/email-manager.aspx");


        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {

            lbltbarvalue.Text = tbarEmailUsage.Value.ToString();
        }

        private void trackBar1_Scroll_1(object sender, EventArgs e)
        {
            lblDatabaseUsage.Text = tbarDatabase.Value.ToString();
        }

        private void CheckNews_Tick_Caller(object sender, EventArgs e)
        {

            System.Threading.ThreadStart thr_start_func2 = new System.Threading.ThreadStart(CheckNews_Tick);
            System.Threading.Thread CheckNewsThread = new System.Threading.Thread(thr_start_func2);
            CheckForIllegalCrossThreadCalls = false;
            CheckNewsThread.Start();

        }

        //Used by HyperLinks within News Section
        public static string AddTarget(string input)
        {
            string prependurl = "";
            Regex stripTags = new Regex("href\\s*=\\s*(?:\"(?<1>[^\"]*)\"|(?<1>\\S+))", RegexOptions.IgnoreCase);
            string hrefvalue = stripTags.Match(input).ToString();
            if (hrefvalue != "")
            {
                if (hrefvalue.Contains("http") || hrefvalue.Contains("https"))
                {
                    prependurl = hrefvalue;
                }
                else
                {
                    if (hrefvalue.Contains("/"))
                    {



                        prependurl = hrefvalue.Replace("/", "http://my.discountasp.net/");
                    }
                    else
                    {
                        int pagestartindex = 0;
                        
                         pagestartindex = hrefvalue.IndexOf('"');
                        int pagedotindex = hrefvalue.IndexOf('.');
                        int pagelength = pagedotindex - pagestartindex + 4;
                        string page = hrefvalue.Substring(6, pagelength);
                        prependurl = "href='http://my.discountasp.net/" + page + "'";


                    }
                }
                string fulllink = prependurl + " target=_blank";
                return stripTags.Replace(input, fulllink);

            }
            else
            {
                return input;
            }
        }
      

        //Called By CheckNews_Tick_Caller every 1.5 hours to check for News
        private void CheckNews_Tick()
        {
            ArrayList NewsList = new ArrayList();
            string date;
            string subject;
            string message;
            
       
       
            try
            {
                if (SettingsEnableFlag != 0 && api.VerifyKey(key))
                {
                    if (ConfigurationManager.AppSettings["StatusNews"] == "Enabled" && SettingsEnableFlag == 1)
                    {
                        txtActivities.Text += "Checking for News..." + "\r\n";
                        txtActivities.Select(txtActivities.Text.Length, 0);
                        txtActivities.ScrollToCaret();

                        DataSet News = new DataSet();
                        News = api.GetNews(key);
                        int count = 0;

                        string msg = "";
                        string NewsDateSubject = ConfigurationManager.AppSettings["lastNews"];



                        if (News.Tables[0].Rows.Count > 0)
                        {


                            lblLoadingNews.Text = "";
                            string fullmessage = "";
                            int counter = 0;

                            foreach (DataRow dr in News.Tables[0].Rows)
                            {
                                date = dr["Date"].ToString();
                                subject = dr["Subject"].ToString();
                                message = dr["Message"].ToString();
                                msg = AddTarget(message);
                                int newsflag = 0;

                                if (NewsDateSubject != null)
                                {
                                    //Update Config File with New Data
                                    Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
                                    count++;
                                    //For the First News Item ,clear the config data
                                    if (count == 1)
                                    {

                                        config.AppSettings.Settings.Remove("lastNews");
                                    }

                                    config.AppSettings.Settings.Add("lastNews", date+"|");
                                    config.AppSettings.Settings.Add("lastNews", subject+"|");
                                    config.Save(ConfigurationSaveMode.Modified);
                                    ConfigurationManager.RefreshSection("appSettings");


                                    int h = 0;
                                    //Adding Config Values into a String Array w/ Every even index as date and Odd index as Subject 
                                    char[] splitter = { '|' };
                                    String[] news = NewsDateSubject.Split(splitter);

                                    while (h <= news.Length - 2)
                                    {
                                        //Check whether Date is same
                                        if (String.Compare(date.ToString(), news[h].ToString()) == 0)
                                        {
                                            //Check whether Subject is the same if the Date was same.
                                          
                                            if (String.Compare(subject.ToString(), news[h + 1].ToString().Substring(1)) == 0)
                                            {

                                                newsflag = 1;

                                            }
                                            else
                                            {
                                                newsflag = 0;
                                            }

                                        }
                                        //If none are same ,its new News            
                                        if (newsflag != 1)
                                        {
                                            //Only Show Data if it was modified
                                            if (h == news.Length - 2)
                                            {
                                                fullmessage += "<u>Date</u> :" + date + " <BR><u>Subject</u> : " + subject + " <BR><u>Message</u><BR><BR> " + msg + "<BR><BR>" + "-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-" + "<BR><BR>";
                                                counter++;

                                            }
                                        }


                                        h = h + 2;
                                    }


                                }
                                else
                                {
                                    Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
                                    config.AppSettings.Settings.Add("lastNews", date);
                                    config.AppSettings.Settings.Add("lastNews", subject);
                                    counter++;
                                    fullmessage += "<u>Date</u> :" + date + " <BR><u>Subject</u> : " + subject + " <BR><u>Message</u><BR><BR> " + msg + "<BR><BR>" + "-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-x-" + "<BR><BR>";
                                    config.Save(ConfigurationSaveMode.Modified);
                                    ConfigurationManager.RefreshSection("appSettings");

                                }


                            }


                            if (fullmessage != "")
                            {

                                lblLoadingNews.Text = "Loading News...";
                                System.Threading.Thread.Sleep(3000);
                                txtActivities.Text += "News Updated...  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                                txtActivities.Select(txtActivities.Text.Length, 0);
                                txtActivities.ScrollToCaret();
                                wbNews.DocumentText = fullmessage;
                                lblLoadingNews.Text = "";
                                NICON.BalloonTipTitle = "DISCOUNTASP.NET ALERT";
                                NICON.BalloonTipText = "You have " + counter.ToString() + " News Alert" + "\n" + "Click here for more Details.";

                                NICON.BalloonTipClicked += delegate(object obj, EventArgs args)
                            {
                                Show();
                                WindowState = FormWindowState.Normal;
                                this.AccountTab.SelectTab("tbAlertSettings");
                                this.tabAlerts.SelectTab("tabNews");

                            };
                                NICON.ShowBalloonTip(5000);
                                if (alertcount < 10)
                                {
                                    lblDiskBWAlert.Text += "Alert Msg: " + "You had " + counter.ToString() + " News Alert" + "    Time : " + DateTime.Now + "\n";
                                    alertcount++;
                                }
                                else
                                {
                                    lblDiskBWAlert.Text = "";
                                    alertcount = 0;
                                    lblDiskBWAlert.Text += "Alert Msg: " + "You had " + counter.ToString() + " News Alert" + "    Time : " + DateTime.Now + "\n";
                                    alertcount++;
                                }
                            }
                            else
                            {
                                System.Threading.Thread.Sleep(3000);
                                wbNews.DocumentText = "No News";
                                txtActivities.Text += "News Updated...  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                                txtActivities.Select(txtActivities.Text.Length, 0);
                                txtActivities.ScrollToCaret();
                            }


                        }

                    }
                }
        }
        catch (Exception ex)
        {
            AccountTab.SelectedIndex = 0;

            if (this.Visible == false)
            {

                NICON.BalloonTipTitle = "ERROR";
                NICON.BalloonTipText = "Service Temporarily Unavailable";
                NICON.ShowBalloonTip(5000);
            }
            else
            {
                MessageBox.Show("Error " + ex.Message.ToString());
                txtActivities.Text += "News cannot be updated at the moment...  -" + DateTime.Now + "\r\n" + "----------------------------------------------------------------------------------" + "\r\n";
                txtActivities.Select(txtActivities.Text.Length, 0);
                txtActivities.ScrollToCaret();
            }

        }

        }
        //Enable/Disable News
        private void btnDisableNews_Click(object sender, EventArgs e)
        {
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            key = ConfigurationManager.AppSettings.Get("key");
            if (btnDisableNews.Text == "Disable")
            {
                btnDisableNews.Text = "Enable";
                pnlNews.Enabled = false;
                if (ConfigurationManager.AppSettings["StatusNews"] != "")
                {
                    config.AppSettings.Settings.Remove("StatusNews");
                    config.AppSettings.Settings.Add("StatusNews", "Disabled");

                }
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");

            }
            else
            {

                btnDisableNews.Text = "Disable";
                pnlNews.Enabled = true;
                if (ConfigurationManager.AppSettings["StatusNews"] != "")
                {
                    config.AppSettings.Settings.Remove("StatusNews");
                    config.AppSettings.Settings.Add("StatusNews", "Enabled");
                }
                config.Save(ConfigurationSaveMode.Modified);
                ConfigurationManager.RefreshSection("appSettings");
                CheckNews_Tick_Caller(sender, e);


            }

        }




    }
}